local ver = "2011.02.07.test2" -- Variable version NOT Add On version
local on = true
local off = false

AchSnd_Defaults = {
-- Default Settings   All settings can be changed in game with
-- the /achsnd command (command = variable name (case insensitive))
Guild = on, -- Enable on guild member achievements
Party = on, -- Enable on party members achievements
Near = on,  -- Enable for people near you
--
-- Addon Output Settings
MSBT = on,  -- Output achievement to Mik's Scrolling Battle Text
Popup = on, -- Grats popup
Sound = on, -- Enable Sound Output
CustomMP3 = off, -- Enable custom alert.mp3
CustomOGG = off, -- Enable custom alert.ogg
Timeout = 15, -- Popup timeout between 0 - 60 secs
Multi = on, -- Enable Multi Guild grats
MultiAmount = 7, -- How Many Guildies before a Whole Guild Grat
Names = on, -- Use player names in random messages
NNames = on, -- Use supplied Nick Names when match found
MaxNames = 5, -- Max number of names to use in message
Random = on, -- Random messages or default
DefaultMsg = "{star} Grats {star}", -- Default Grats Message
NewMsgBox = on, -- Enables the new Achievement Alert frame
AutoFade = on, -- Enables new alert frame to auto-fade when mouse not over it
MinAlpha = 35, -- Minimum alpha the frame will fade to
FadeDelay = 3, -- How long before frame fades to above alpha
--
-- Addon State
Enable = on -- enable/disable the addon 
}

AchSnd_DefaultsPC = {
ver = "unknown", -- Version update for variable changes
AlertPosSet = false --Per char alert box pos saved
}


AchSnd_Settings = {}
AchSnd_SettingsPC = {}
AchSnd_NN = {} -- Nicknames
local NN -- Alias for AchSnd_NN[Realm]

AchSnd={}
AchSnd.MBox = {}
AchSnd.MBox.Test = false
AchSnd.MBox.Mode = {say = {}, guild = {}, party = {} }

AchSnd.Frame = CreateFrame("Frame")
AchSnd.Frame:RegisterEvent("ADDON_LOADED")
AchSnd.Frame:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
AchSnd.Frame:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")

-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"

-- Bill's Utils
local addOptionMt = BillsUtils.addOptionMt
local StatColor = BillsUtils.StatColor
local SJprint = BillsUtils.SJprint
local LinkedSort = BillsUtils.LinkedSort
local OptSaveTF = BillsUtils.OptSaveTF
local OptSaveVal = BillsUtils.OptSaveVal

AchSnd.VerUpdateTF = function( Table, ... )
	Key = {...}
	
	for x = 1, #Key do
		local vtype = type(Table[Key[x]])
		if vtype == "string" then
			if Table[Key[x]] == "on" then
				Table[Key[x]] = true
			else
				Table[Key[x]] = false
			end
		elseif vtype == "number" then
			if Table[Key[x]] == 1 then
				Table[Key[x]] = true
			else
				Table[Key[x]] = false
			end
		end
	end
end


AchSnd.VerUpdate = function()
	print(" AchSnd: Ver Update Running")
	AchSnd.VerUpdateTF( AchSnd_Settings , "Guild", "Party", "Near", "MSBT", "Popup", "Sound", "CustomMP3", "CustomOGG", --
		"Multi", "Names", "NNames", "Random", "NewMsgBox", "AutoFade", "Enable")
	AchSnd.VerUpdateTF( AchSnd_SettingsPC, "AlertPosSet" )
	
	if AchSnd_Settings.MinAlpha > 0 and AchSnd_Settings.MinAlpha < 1 then
		AchSnd_Settings.MinAlpha = math.ceil(AchSnd_Settings.MinAlpha * 100)
	end
		
	AchSnd_SettingsPC.ver = ver
end

AchSnd.TextScanError  = function( text )
	for loop = 1, #text do
		if (string.byte( text, loop) > 127) then
			return true
		end
	end
	return false
end




StaticPopupDialogs["AchSnd.TextError"] = {
	text = "Message text cannot contain characters with an ASCII value greater than 127",
	button1 = "Okay",
	timeout = 20,
	showAlert = true
	}



AchSnd.NickNames = function( msg )
	local cmd, arg, nick = string.split(" ", msg)
	cmd = cmd:lower()
	
	if cmd == "nn" or cmd == "nnames" then
		_, cmd, arg, nick =  string.split(" ", msg)
		cmd = cmd:lower()
	end
	
	local name = arg
	
	if cmd == "on" or cmd == "off" then
		AchSnd_Settings.NNames = (cmd == "on")
		SJprint( yel, "Achievement Sounds: NNames is", StatColor( AchSnd_Settings.NNames ), res)
		return
	end
		
	
	if (cmd == "add") then
		local set = false
		
		if name == nil or nick == nil then
			SJprint( yel, " Achievement Sounds: Nick Name entry error \n \"/asnn add NAME NICKNAME\"", res)
			return
		end
	
		if #NN.Names > 0 then
			for x = 1, #NN.Names do
				if NN.Names[x] == name then
					NN.Nicks[x] = nick
					set = true
				end
			end
		end
	
		if not(set) then
			local index
			if #NN.Names == nil then
				index = 1
			else
				index = #NN.Names + 1
			end
			
			NN.Names[index] = name
			NN.Nicks[index] = nick
		end

		SJprint( yel, " Achievement Sounds: Nickname stored as NAME:", name, "  NICKNAME:", nick , res)
		LinkedSort(NN.Names, NN.Nicks)
		return
	end

	if (cmd == "rem") then
		local rem = false
		local number = tonumber(name)
		
		if name == nil then
			SJprint( yel, " Achievement Sounds: Nick Name entry error \n \"/asnn rem NAME \"", res)
			return
		end
	
		if #NN.Names > 0 and number == nil then
			for x = 1, #NN.Names do
				if NN.Names[x] == name then
					table.remove(NN.Names, x)
					table.remove(NN.Nicks, x)
					rem = true
				end
			end
		end
		
		if number > 0 and number <= #NN.Names then
			name = NN.Names[number]
			table.remove(NN.Names, number)
			table.remove(NN.Nicks, number)
			rem = true
		end
		
		if not(rem) then
			SJprint( yel, " Achievement Sounds: Error \n Unable to find NAME:", name, " to remove from nickname list", res)
		else
			SJprint( yel, " Achievement Sounds: NAME:", name, " removed from nickname list", res)
		end
		return	
	end
		
	if (cmd == "display") then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Nick Names List", res)
		SJprint( yel, "#  NAME:               NICK:", res)
		if #NN.Names > 0 then
			for x = 1, #NN.Names do
				SJprint( yel, x, " ", NN.Names[x], string.rep( " ",15 - #NN.Names[x]), NN.Nicks[x], "\n", res)
			end
		else
			SJprint( yel, "ERROR: No Nicknames Stored", res)
		end
		return
	end
	
	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Achievement Sounds", res)
	SJprint( yel, "  Nick Names", res)
	if cmd ~= "" then
		SJprint( red, "  Error:", cmd, "is not a valid command", res)
		SJprint( yel, "Valid commands are as follows\n", res)
	end
	
	SJprint( blu, "  /achsnd nnames cmd", yel, "or", blu, "/achsnd nn cmd", res)
	SJprint( blu, "  /asnn cmd", res)
	SJprint( yel, "  Commands are:", res)
	SJprint( blu, "     on", yel, "/", blu, "off", wht, "Turns Nick Names on and off", res)
	SJprint( blu, "     add", wht, "Adds or replaces a nickname \"/asnn add NAME NICKNAME\"", res)
	SJprint( blu, "     rem", wht, "Removes a nickname \"/asnn rem NAME\" or \"/asnn rem NUMBER\"", res)
	SJprint( blu, "     display", wht, "Displays list of saved nicknames", res)
	print(" ")
	SJprint( yel, "Achievement Sounds: NNames is", StatColor( AchSnd_Settings.NNames ), res)
	SJprint( yel, "and ", #NN.Names, "nicknames are stored.")
	return
end


AchSnd.CleanNames = function()
	local guild = AchSnd.MBox.Mode.guild
	local party = AchSnd.MBox.Mode.party
	local say = AchSnd.MBox.Mode.say
	
	table.sort( guild )
	table.sort( party )
	table.sort( say )
	
	-- removes dupes in Guild Que
	if #guild > 1 then
		for x = #guild -1 , 1, -1 do
			if guild[x] == guild[x+1] then
				table.remove(guild, x+1)
			end
		end
	end

	-- removes dupes in Party Que
	if #party > 1 then
		for x = #party -1 , 1, -1 do
			if party[x] == party[x+1] then
				table.remove(party, x+1)
			end
		end
	end
	
	-- removes dupes in Say Que
	if #say > 1 then
		for x = #say -1 , 1, -1 do
			if say[x] == say[x+1] then
				table.remove(say, x+1)
			end
		end
	end
	
	-- removes dupes in Say / Party Que compared to Guild Que
	if #guild > 0 then
		for x = 1, #guild do
			if #party > 0 then
				for y = #party, 1, -1 do
					if guild[x] == party[y] then
						table.remove(party, y)
					end
				end
			end
			if #say > 0 then
				for y = #say, 1, -1 do
					if guild[x] == say[y] then
						table.remove(say, y)
					end
				end
			end
		end
	end
	
	-- removes dupes in Say Que compared to Party Que
	if #party > 0 then
		for x = 1, #party do
			if #say > 0 then
				for y = #say, 1, -1 do
					if party[x] == say[y] then
						table.remove( say, y)
					end
				end
			end
		end
	end
end


AchSnd.Nicks = function()
	local guild = AchSnd.MBox.Mode.guild
	local party = AchSnd.MBox.Mode.party
	local say = AchSnd.MBox.Mode.say
	
	if #guild > 0 then
		for x = 1, #guild do
			for y = 1, #NN.Names do
				if guild[x] == NN.Names[y] then
					guild[x] = NN.Nicks[y]
				end
			end
		end
	end
	
	if #party > 0 then
		for x = 1, #party do
			for y = 1, #NN.Names do
				if party[x] == NN.Names[y] then
					party[x] = NN.Nicks[y]
				end
			end
		end
	end
	
	if #say > 0 then
		for x = 1, #say do
			for y = 1, #NN.Names do
				if say[x] == NN.Names[y] then
					say[x] = NN.Nicks[y]
				end
			end
		end
	end
end
	

AchSnd.RandMsg=function()
--prefix and postfix must be in matching pairs
	local prefix = {"{star}{star}", "{circle}{circle}", "{diamond}{diamond}", "{triangle}{triangle}",	--prints raid icons
				"{moon}{moon}", "{square}{square}", "{x}{x}", "{skull}{skull}",							--to guild/party
				"{star}", "{circle}", "{diamond}", "{triangle}",										--chat only
				"{moon}", "{square}", "{x}", "{skull}",													--looks stupid in SAY

-- Above 16 not for SAY... put new non-say-able pair halves above this line	and increment sayoffset var
-- and say-able pair halves below this line 
				"..||..<(+_", "-o--{", "<(  0)>", "- - --^[", "( ' __ ' )",
				">--->", "<'))))><", ".||.<(+_+)>.||/.", "-<<ALERT>>-", "->]",
				"--<-@", "->>X<<-"
			}

	local postfix = {"{star}{star}", "{circle}{circle}", "{diamond}{diamond}", "{triangle}{triangle}",
				"{moon}{moon}", "{square}{square}", "{x}{x}", "{skull}{skull}",
				"{star}", "{circle}", "{diamond}", "{triangle}",
				"{moon}", "{square}", "{x}", "{skull}",
				
-- Above 16 not for SAY... put new non-say-able pair halves above this line	and increment sayoffset var
-- and say-able pair halves below this line 
				"_+)>..||..", "}--o-", "<(0  )>", "]^-- - -", "( ' __ ' )",
				"<---<", "><(((('>", ".||.<(+_+)>.||/.", "-<<ALERT>>-", "[<-",
				"@->--", "->>X<<-",
			}
	local sayoffset = 16
	
	local grtz = {"Grats" , "Congratulations" , "Gratz" , "Grats on the Ach." , "GrAtS" , "Congrats", "CoNgRaTs"}
	
	local plurals = {"My Guildies", "Guildies", "Peeps", "Peoples", "Everyone", "to All of You"}
	local notguildoffset = 2
	
	local fixnum = 0
	local multi = AchSnd_Settings.Multi
	local multiamount =  AchSnd_Settings.MultiAmount
	local names = AchSnd_Settings.Names
	local maxnames = AchSnd_Settings.MaxNames
	local mode = ""
	local GUILD = GetGuildInfo("player")
	local wholeguild = false
	local fixnum = 0
	local gratnum = 0
	local plurnum = 0
	local count = 0
	local playernames
	
	if AchSnd_Settings.NNames then
		AchSnd.Nicks()
	end
	
	AchSnd.CleanNames()
	
	while #AchSnd.MBox.Mode.guild > 0 or #AchSnd.MBox.Mode.party > 0 or #AchSnd.MBox.Mode.say > 0 do
		if #AchSnd.MBox.Mode.guild > 0 then
			mode = "GUILD"
			fixnum = math.random(1, #prefix)
			gratnum = math.random(1, #grtz)
			plurnum = math.random(1, #plurals)
			playernames = AchSnd.MBox.Mode.guild
			for x = 1, #playernames do
				if playernames[x] == GUILD then
					wholeguild = true
				end
			end
		elseif #AchSnd.MBox.Mode.party > 0 then
			mode = "PARTY"
			fixnum = math.random(1, #prefix)
			gratnum = math.random(1, #grtz)
			plurnum = math.random(1 + notguildoffset, #plurals)
			playernames = AchSnd.MBox.Mode.party
		elseif #AchSnd.MBox.Mode.say > 0 then
			mode = "SAY"
			fixnum = math.random(1 + sayoffset , #prefix)
			gratnum = math.random(1, #grtz)
			plurnum = math.random(1 + notguildoffset, #plurals)
			playernames = AchSnd.MBox.Mode.say
		else
			return
		end
		
		count = #playernames
		
		if multi and (count > 1 or wholeguild ) then
			if count > multiamount or wholeguild then
				SendChatMessage( string.format("%s %s %s %s",prefix[fixnum],grtz[ gratnum ],plurals[ plurnum ],postfix[fixnum]), mode )
			else
				if names and count <= maxnames then
					local retstr = ""
					for x = 1, count do
						retstr = retstr..string.format("[%s]", playernames[x] )
						if (x < (count - 1)) then
							retstr = retstr..", "
						elseif (x == (count - 1))	then
							retstr = retstr.." and "
						end
					end
					SendChatMessage( string.format("%s %s %s %s",prefix[fixnum],grtz[ gratnum ],retstr ,postfix[fixnum]), mode )
				else
					SendChatMessage( string.format("%s %s You %i %s",prefix[fixnum],grtz[ gratnum ],count ,postfix[fixnum]), mode )
				end
			end
			
		else -- not multi or single grat
			if names then
				SendChatMessage( string.format("%s %s %s %s",prefix[fixnum],grtz[ gratnum ], playernames[1], postfix[fixnum]), mode )
			else
				SendChatMessage( string.format("%s %s %s",prefix[fixnum],grtz[ gratnum ],postfix[fixnum]), mode )
			end
		end
		
		wholeguild = false
		
		if mode == "GUILD" or not( multi ) then
			wipe(AchSnd.MBox.Mode.guild)
		end
		if mode == "PARTY" or not ( multi ) then
			wipe(AchSnd.MBox.Mode.party)
		end
		if mode == "SAY" or not( multi ) then
			wipe(AchSnd.MBox.Mode.say)
		end
	end
	return 
end


AchSnd.DefMsg=function()
	if not(AchSnd_Settings.Multi) then
		if ( #AchSnd.MBox.Mode.guild > 0 ) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "GUILD" )
		elseif ( #AchSnd.MBox.Mode.party > 0 ) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "PARTY" )
		elseif ( #AchSnd.MBox.Mode.say > 0	) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "SAY" )
		end
	else
		if ( #AchSnd.MBox.Mode.guild > 0 ) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "GUILD" )
		end
		if ( #AchSnd.MBox.Mode.party > 0 ) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "PARTY" )
		end
		if ( #AchSnd.MBox.Mode.say > 0 ) then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "SAY" )
		end
	end
	wipe(AchSnd.MBox.Mode.guild)
	wipe(AchSnd.MBox.Mode.party)
	wipe(AchSnd.MBox.Mode.say)
end


AchSnd.Frame:SetScript("OnEvent",function(self, event,...)
	if event == "ADDON_LOADED" then
		local arg = ...
		if arg ~= "AchSnd" then
			return
		end
		
		print("\n\nAchievement Sounds loaded\n\n")
		addOptionMt( AchSnd_Settings , AchSnd_Defaults )
		addOptionMt( AchSnd_SettingsPC , AchSnd_DefaultsPC )
		
		if (AchSnd_SettingsPC.ver ~= ver) then
			AchSnd.VerUpdate()
		end
		
		if not(AchSnd_SettingsPC.AlertPosSet) and AchSnd_Settings.NewMsgBox then
			AchSnd.MsgFrame:Show()
		end
		
		local realm = GetRealmName()
		local set = false
		
		if #AchSnd_NN > 0 then
			for x = 1, #AchSnd_NN do
				if AchSnd_NN[x].Realm == realm then
					NN = AchSnd_NN[x]
					set = true
				end
			end
		end
		
		if #AchSnd_NN == nil and not(set) then
			AchSnd_NN[1] = { Nicks = {}, Names = {}, Realm = realm}
			NN = AchSnd_NN[1]
			set = true
		end
		
		if not(set) then
			local index = #AchSnd_NN + 1
			AchSnd_NN[index] = {Realm = realm, Names = {}, Nicks = {}}
			NN = AchSnd_NN[index]
		end
		
		return self, event, ...
	end
	
	if not(AchSnd_Settings.Enable) then
		return
	end
	
	local args = {...}
	local color = {255,255,255}
	local msg = args[1]:format(args[5])
	local name = args[5]
	
	if name == UnitName("player") then
		return
	end
	
	if event == "CHAT_MSG_ACHIEVEMENT" then
		if UnitInParty( name ) then
			if not(AchSnd_Settings.Party) then 
				return
			end
			color = {0,255,255}
			AchSnd.MBox.Mode.party[#AchSnd.MBox.Mode.party + 1] = name
		else
			if not(AchSnd_Settings.Near)then
				return
			end
			color = {255,255,255}
			AchSnd.MBox.Mode.say[#AchSnd.MBox.Mode.say + 1] = name
		end
	end
	
	if event == "CHAT_MSG_GUILD_ACHIEVEMENT" then
		if not(AchSnd_Settings.Guild) then
			return
		end
		color = {0,255,0}
		AchSnd.MBox.Mode.guild[#AchSnd.MBox.Mode.guild + 1] = name
	end
	
	if AchSnd_Settings.MSBT and IsAddOnLoaded("MikScrollingBattleText") then
		if not(MikSBT.IsModDisabled()) then
			MikSBT.DisplayMessage( msg , MikSBT.DISPLAYTYPE_NOTIFICATION, true, color[1], color[2], color[3])
		end
	end

	if AchSnd_Settings.Sound then
		if AchSnd_Settings.CustomMP3 then
			PlaySoundFile("Interface\\AddOns\\AchSnd\\alert.mp3")
		elseif AchSnd_Settings.CustomOGG then
			PlaySoundFile("Interface\\AddOns\\AchSnd\\alert.ogg")
		else
			PlaySound("LEVELUPSOUND")
		end
	end
	
	if AchSnd_Settings.Popup then
		if AchSnd_Settings.NewMsgBox then
			AchSnd.MBox.text = msg
			AchSnd.MsgFrame:Show()
		else
			
			local mode = AchSnd.MBox.Mode
			local Button1Txt = ""
			if #mode.say > 0 and #mode.guild == 0 and #mode.party == 0 then
				Button1Txt = "Say Grats"
			elseif #mode.say == 0 and #mode.guild > 0 and #mode.party == 0 then
				Button1Txt = "Guild Grats"
			elseif #mode.say == 0 and #mode.guild == 0 and #mode.party > 0 then
				Button1Txt = "Party Grats"
			else
				Button1Txt = "Mixed Grats"
			end
			
			StaticPopupDialogs["AchSnd.PopUp"] = {
			text = msg,
			button1 = Button1Txt ,
			button2 = "Cancel",
			OnAccept = function(self)
				if AchSnd_Settings.Random then
					AchSnd.RandMsg()
				else
					AchSnd.DefMsg()
				end
			end,
			OnCancel = function( self )
				wipe(AchSnd.MBox.Mode.guild)
				wipe(AchSnd.MBox.Mode.party)
				wipe(AchSnd.MBox.Mode.say)
			end,
			timeout = AchSnd_Settings.Timeout
			}	
			StaticPopup_Show("AchSnd.PopUp")
		end
	else
		wipe(AchSnd.MBox.Mode.guild)
		wipe(AchSnd.MBox.Mode.party)
		wipe(AchSnd.MBox.Mode.say)
	end
end)



SLASH_ACHSND1 = "/achsnd"
SLASH_ACHSND2 = "/achievementsounds"
SlashCmdList["ACHSND"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
		
	if cmd =="config" then
		InterfaceOptionsFrame_OpenToCategory( AchSnd.panel )
		return
	end
	
	if cmd == "enable" then
		OptSaveTF( AchSnd_Settings, "Enable", arg)
		SJprint( yel, "Achievement Sounds: Enable is", StatColor(AchSnd_Settings.Enable), res)
		if not(AchSnd_Settings.Enable) then
			SJprint( yel, "Add On is", red, "DISABLED", res)
			SJprint( yel, "Type:", blu, "/achsnd enable on", yel, "to turn add on back on")
		end
		return
	end
	
	if not(AchSnd_Settings.Enable) then
		print(" ")
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  This addon is ", red, "DISABLED", res)
		SJprint( yel, "  Type: ", blu, "/achsnd enable on", res)
		SJprint( yel, "  to enable.", res)
		return
	end
	
	if cmd == "" then
		print(" ")
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Addon State:", res)
		SJprint( blu, "     Enable", wht, "is", StatColor(AchSnd_Settings.Enable), res)
		SJprint( yel, "  Triggers:", res)
		SJprint( blu, "     Guild", wht, "achievements are", StatColor(AchSnd_Settings.Guild), res)
		SJprint( blu, "     Party", wht, "achievements are", StatColor(AchSnd_Settings.Party), res)
		SJprint( blu, "     Near ", wht, "achievements are", StatColor(AchSnd_Settings.Near), res)
		SJprint( yel, "  Outputs:", res)
		SJprint( blu, "     Sound", wht, "is", StatColor(AchSnd_Settings.Sound), res)
		SJprint( blu, "     CustomMP3", wht, "is", StatColor(AchSnd_Settings.CustomMP3), res)
		SJprint( blu, "     CustomOGG", wht, "is", StatColor(AchSnd_Settings.CustomOGG), res)
		SJprint( blu, "     MSBT ", wht, "is", StatColor(AchSnd_Settings.MSBT), res)
		SJprint( blu, "     Popup", wht, "is", StatColor(AchSnd_Settings.Popup), res)
		SJprint( blu, "     Timeout", wht, "is", StatColor(AchSnd_Settings.Timeout), res)
		SJprint( blu, "     Multi", wht, "is", StatColor(AchSnd_Settings.Multi), res)
		SJprint( blu, "     MultiAmount", wht, "is", grn, AchSnd_Settings.MultiAmount, res)
		SJprint( blu, "     Names", wht, "is", StatColor(AchSnd_Settings.Names), res)
		SJprint( blu, "     NNames", wht, "is", StatColor(AchSnd_Settings.NNames), res)
		SJprint( blu, "     MaxNames", wht, "is", grn, AchSnd_Settings.MaxNames, res)
		SJprint( blu, "     Random", wht, "is", StatColor(AchSnd_Settings.Random), res)
		SJprint( blu, "     DefaultMsg", wht, "is \"", grn, AchSnd_Settings.DefaultMsg, wht, "\"", res)
		SJprint( blu, "     NewMsgBox", wht, "is", StatColor(AchSnd_Settings.NewMsgBox), res)
		SJprint( blu, "     MinAlpha", wht, "is", grn, AchSnd_Settings.MinAlpha, res)
		SJprint( blu, "     FadeDelay", wht, "is", StatColor(AchSnd_Settings.FadeDelay), res)
		SJprint( yel, "Available commands are listed above in", blu, "BLUE.", res)
		SJprint( yel, "Type", blu, "/achsnd config", yel, "to open the GUI config screen.", res)
		SJprint( yel, "Type", blu, "/achsnd cmdlist", yel, "for a description of commands.", res)
		SJprint( yel, "________________________________________", res)
		return
	end

	if cmd == "cmdlist" then
		print(" ")
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Addon State:", res)
		SJprint( blu, "     Enable", wht, "Turns the Add On on and off", res)
		SJprint( yel, "  Triggers:", res)
		SJprint( blu, "     Guild", wht, "Enable for guild member achievements ( on / off)", res)
		SJprint( blu, "     Party", wht, "Enable for party member achievements ( on / off)", res)
		SJprint( blu, "     Near ", wht, "Enable for achievements of people near you ( on / off)", res)
		SJprint( yel, "  Outputs:", res)
		SJprint( blu, "     Sound", wht, "Enable a sound when an achievement is detected ( on / off)", res)
		SJprint( blu, "     CustomMP3", wht, "Enable a custom alert.mp3 when an achievement is detected ( on / off)", res)
		SJprint( blu, "     CustomOGG", wht, "Enable a custom alert.ogg when an achievement is detected ( on / off)", res)
		SJprint( blu, "     MSBT", wht, "Send the achievement text to MikScrollingBattleText ( on / off)", res)
		SJprint( blu, "     Popup", wht, "Show a Popup when an achievement is detected ( on / off)", res)
		SJprint( blu, "     Timeout", wht, "How long before the popup closes itself (0 - 60 seconds)", res)
		SJprint( blu, "     Multi", wht, "Detect when more than one guild member gets an achievement ( on / off)", res)
		SJprint( blu, "     MultiAmount", wht, "Over this amount give a whole guild grats instead of normal grat", res)
		SJprint( blu, "     Names", wht, "Display Names in the random grats", res)
		SJprint( blu, "     NNames", wht, "Displays NickNames for players names if saved. \n Type \"", blu, "/asnn", wht, "\"for more info", res)
		SJprint( blu, "     MaxNames", wht, "Max number of names to display (should be around 5 or gets spammy)\n     (Max is 10)", res)
		SJprint( blu, "     Random", wht, "Display a random grat instead of default one ( on / off)", res)
		SJprint( blu, "     DefaultMsg", wht, "The default message if Random is off", res)
		SJprint( blu, "     NewMsgBox", wht, "Enables moveable popup instead of old style popup ( on / off)", res)
		SJprint( blu, "     MinAlpha", wht, "The minimum the new frame is allowed to fade to (0 - 1)", res)
		SJprint( blu, "     FadeDelay", wht, "How long the newly shown popup will be visible at 100% before fading (0 - Timeout seconds)", res)
		SJprint( yel, "Available commands are listed above in ", blu, "BLUE.", res)
		SJprint( yel, "Type ", blu, "/achsnd config",  yel, " to open the GUI config screen.", res)
		SJprint( yel, "________________________________________", res)
		return
	end


	if cmd == "guild" then
		OptSaveTF( AchSnd_Settings, "Guild", arg)
		SJprint( yel, "Achievement Sounds: Guild is", StatColor(AchSnd_Settings.Guild), res)
		return
	end
	
	if cmd == "party" then
		OptSaveTF( AchSnd_Settings, "Party", arg)
		SJprint( yel, "Achievement Sounds: Party is", StatColor(AchSnd_Settings.Party), res)
		return
	end

	if cmd == "near" then
		OptSaveTF( AchSnd_Settings, "Near", arg)
		SJprint( yel, "Achievement Sounds: Near is", StatColor(AchSnd_Settings.Near), res)
		return
	end

	if cmd == "sound" then
		OptSaveTF( AchSnd_Settings, "Sound", arg)
		SJprint( yel, "Achievement Sounds: Sound is", StatColor(AchSnd_Settings.Sound), res)
		return
	end

	if cmd == "msbt" then
		OptSaveTF( AchSnd_Settings, "MSBT", arg)
		SJprint( yel, "Achievement Sounds: MSBT is", StatColor(AchSnd_Settings.MSBT), res)
		if not(IsAddOnLoaded("MikScrollingBattleText")) and AchSnd_Settings.MSBT then
			SJprint( yel, "Mik's Scrolling Battle Text is not loaded so text will not display in the MSBT frame", res)
		end
		return
	end

	if cmd == "popup" then
		OptSaveTF( AchSnd_Settings, "Popup", arg)
		SJprint( yel, "Achievement Sounds: Popup is", StatColor(AchSnd_Settings.Popup), res)
		return
	end
	
	if cmd == "timeout" then
		OptSaveVal( AchSnd_Settings, "Timeout", arg, 0, 60)
		SJprint( yel, "Achievement Sounds: Timeout is", StatColor(AchSnd_Settings.Timeout), res)
		return
	end

	if cmd == "random" then
		OptSaveTF( AchSnd_Settings, "Random", arg)
		SJprint( yel, "Achievement Sounds: Random is", StatColor(AchSnd_Settings.Random), res)
		return
	end

	if cmd == "defaultmsg" then
		if arg then
			if AchSnd.TextScanError(arg) then
				StaticPopup_Show("AchSnd.TextError")
				return
			end
			AchSnd_Settings.DefaultMsg = string.trim(string.sub( msg, #cmd +1))
		end
		SJprint( yel, "Achievement Sounds: DefaultMsg is \"", grn, AchSnd_Settings.DefaultMsg, yel, "\"", res)
		return
	end

	if cmd == "newmsgbox" then
		OptSaveTF( AchSnd_Settings, "NewMsgBox", arg)
		SJprint( yel, "Achievement Sounds: NewMsgBox is", StatColor(AchSnd_Settings.NewMsgBox), res)
		return
	end

	if cmd == "minalpha" then
		OptSaveVal( AchSnd_Settings, "MinAlpha", arg, 0, 100)
		SJprint( yel, "Achievement Sounds: MinAlpha is", grn, AchSnd_Settings.MinAlpha, res)
	end
	
	if cmd == "fadedelay" then
		OptSaveVal( AchSnd_Settings, "FadeDelay", arg, 0, AchSnd_Settings.Timeout )
		SJprint( yel, "Achievement Sounds: FadeDelay is", StatColor(AchSnd_Settings.FadeDelay), res)
	end

	if cmd == "multi" then
		OptSaveTF( AchSnd_Settings, "Multi", arg)
		SJprint( yel, "Achievement Sounds: Multi is", StatColor(AchSnd_Settings.Multi), res)
		return
	end

	if cmd == "multiamount" then
		OptSaveVal( AchSnd_Settings, "MultiAmount", arg, 0, 129)
		SJprint( yel, "Achievement Sounds: MultiAmount is", grn, AchSnd_Settings.MultiAmount, res)
		return
	end
	
	if cmd == "names" then
		OptSaveTF( AchSnd_Settings, "Names", arg)
		SJprint( yel, "Achievement Sounds: Names is", StatColor(AchSnd_Settings.Names), res)
		return
	end
	
	if cmd == "maxnames" then
		OptSaveVal( AchSnd_Settings, "MaxNames", arg, 0, 10)
		SJprint( yel, "Achievement Sounds: MaxNames is", grn, AchSnd_Settings.MaxNames, res)
		return
	end
	
	if cmd == "nn" or cmd == "nnames" then
		AchSnd.NickNames( msg )
		print(" ")
		SJprint(yel, "try ", blu, "/asnn", yel, "for less typing.", res)
		return
	end

	if cmd == "custommp3" then
		OptSaveTF( AchSnd_Settings, "CustomMP3", arg)
		SJprint( yel, "Achievement Sounds: CustomMP3 is", StatColor(AchSnd_Settings.CustomMP3), res)
		return
	end

	if cmd == "customogg" then
		OptSaveTF( AchSnd_Settings, "CustomOGG", arg)
		SJprint( yel, "Achievement Sounds: CustomOGG is", StatColor(AchSnd_Settings.CustomOGG), res)
		return
	end

	print(" ")
	SJprint( yel, "  Achievement Sounds", res)
	SJprint( yel, "  Error: ", red, cmd, yel, " is not a valid command", res)
	SJprint( yel, "  Type: ", blu, "/achsnd", yel, "for the addon status and command list", res)
	SJprint( yel, "  Type: ", blu, "/achsnd cmdlist", yel, "for command list help", res)
	return
end

SLASH_ACHSNDNN1 = "/asnn"
SlashCmdList["ACHSNDNN"] = function(msg)
	AchSnd.NickNames(msg)
end

